package com.xxl.job.admin.core.complete;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.xxl.job.admin.core.conf.XxlJobAdminConfig;
import com.xxl.job.admin.core.model.XxlJobInfo;
import com.xxl.job.admin.core.model.XxlJobLog;
import com.xxl.job.admin.core.thread.JobTriggerPoolHelper;
import com.xxl.job.admin.core.trigger.TriggerTypeEnum;
import com.xxl.job.admin.core.util.I18nUtil;
import com.xxl.job.core.biz.model.ReturnT;
import java.text.MessageFormat;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class XxlJobCompleter {
  private static Logger logger = LoggerFactory.getLogger(com.xxl.job.admin.core.complete.XxlJobCompleter.class);
  
  public static int updateHandleInfoAndFinish(XxlJobLog xxlJobLog) {
    finishJob(xxlJobLog);
    if (xxlJobLog.getHandleMsg().length() > 15000)
      xxlJobLog.setHandleMsg(xxlJobLog.getHandleMsg().substring(0, 15000)); 
    return XxlJobAdminConfig.getAdminConfig().getXxlJobLogDao().updateHandleInfo(xxlJobLog);
  }
  
  private static void finishJob(XxlJobLog xxlJobLog) {
    String triggerChildMsg = null;
    if (200 == xxlJobLog.getHandleCode()) {
      XxlJobInfo xxlJobInfo = XxlJobAdminConfig.getAdminConfig().getXxlJobInfoDao().loadById(xxlJobLog.getJobId());
      if (xxlJobInfo != null && xxlJobInfo.getChildJobId() != null && xxlJobInfo.getChildJobId().trim().length() > 0) {
        triggerChildMsg = "<br><br><span style=\"color:#00c0ef;\" > >>>>>>>>>>>" + I18nUtil.getString("jobconf_trigger_child_run") + "<<<<<<<<<<< </span><br>";
        String[] childJobIds = xxlJobInfo.getChildJobId().split(",");
        for (int i = 0; i < childJobIds.length; i++) {
          int childJobId = (childJobIds[i] != null && childJobIds[i].trim().length() > 0 && isNumeric(childJobIds[i])) ? Integer.valueOf(childJobIds[i]).intValue() : -1;
          if (childJobId > 0) {
            if (childJobId == xxlJobLog.getJobId()) {
              logger.debug(">>>>>>>>>>> xxl-job, XxlJobCompleter-finishJob ignore childJobId,  childJobId {} is self.", Integer.valueOf(childJobId));
            } else {
              JobTriggerPoolHelper.trigger(childJobId, TriggerTypeEnum.PARENT, -1, null, null, null);
              ReturnT<String> triggerChildResult = ReturnT.SUCCESS;
              triggerChildMsg = triggerChildMsg + MessageFormat.format(I18nUtil.getString("jobconf_callback_child_msg1"), new Object[] { Integer.valueOf(i + 1), 
                    Integer.valueOf(childJobIds.length), childJobIds[i], 
                    
                    (triggerChildResult.getCode() == 200) ? I18nUtil.getString("system_success") : I18nUtil.getString("system_fail"), triggerChildResult
                    .getMsg() });
            } 
          } else {
            triggerChildMsg = triggerChildMsg + MessageFormat.format(I18nUtil.getString("jobconf_callback_child_msg2"), new Object[] { Integer.valueOf(i + 1), 
                  Integer.valueOf(childJobIds.length), childJobIds[i] });
          } 
        } 
      } 
    } 
    if (triggerChildMsg != null)
      xxlJobLog.setHandleMsg(xxlJobLog.getHandleMsg() + triggerChildMsg); 
  }
  
  private static boolean isNumeric(String str) {
    try {
      int result = Integer.valueOf(str).intValue();
      return true;
    } catch (NumberFormatException e) {
      return false;
    } 
  }
}
